Index: issm/trunk/src/m/classes/SMBgemb.m
===================================================================
--- issm/trunk/src/m/classes/SMBgemb.m	(revision 25994)
+++ issm/trunk/src/m/classes/SMBgemb.m	(revision 26744)
@@ -22,6 +22,7 @@
 		isdensification;
 		isturbulentflux;
+		isconstrainsurfaceT;
 		isclimatology;
-		isconstrainsurfaceT;
+		isdeltaLWup;
 
 		%inputs:
@@ -41,6 +42,8 @@
 
 		%optional inputs:
-		aValue = NaN; %Albedo forcing at every element.  Used only if aIdx == 0.
-		teValue = NaN; %Outward longwave radiation thermal emissivity forcing at every element (default in code is 1)
+		aValue = NaN; %Albedo forcing at every element.  Used only if aIdx == 0, or density exceeds adThresh
+		teValue = NaN; %Outward longwave radiation thermal emissivity forcing at every element (default in code is 1). 
+		               %Used only if eIdx== 0, or effective grain radius exceeds teThresh
+		dulwrfValue = NaN; %Delta with which to perturn the long wave radiation upwards. Use if isdeltaLWup is true;  
 
 		% Initialization of snow properties
@@ -53,4 +56,5 @@
 		Wini = NaN; %Water content (kg m-2)
 		Aini = NaN; %albedo (0-1)
+		Adiffini = NaN; %albedo, diffusive radiation (0-1)
 		Tini = NaN; %snow temperature (K)
 		Sizeini = NaN; %Number of layers
@@ -58,27 +62,32 @@
 		%settings:
 		aIdx   = NaN; %method for calculating albedo and subsurface absorption (default is 1)
-			      % 0: direct input from aValue parameter
-			      % 1: effective grain radius [Gardner & Sharp, 2009]
-			      % 2: effective grain radius [Brun et al., 1992; LeFebre et al., 2003]], with swIdx=1, SW penetration follows grain size in 3 spectral bands (Brun et al., 1992)
-			      % 3: density and cloud amount [Greuell & Konzelmann, 1994]
-			      % 4: exponential time decay & wetness [Bougamont & Bamber, 2005]
-
-		swIdx  = NaN; % apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 1, with snow density (taken from Bassford, 2004))
+		% 0: direct input from aValue parameter, no use of adThresh
+		% 1: effective grain radius [Gardner & Sharp, 2009]
+		% 2: effective grain radius [Brun et al., 1992; LeFebre et al., 2003]], with swIdx=1, SW penetration follows grain size in 3 spectral bands (Brun et al., 1992)
+		% 3: density and cloud amount [Greuell & Konzelmann, 1994]
+		% 4: exponential time decay & wetness [Bougamont & Bamber, 2005]
+
+		eIdx   = NaN; %method for calculating emissivity (default is 1)
+		% 0: direct input from teValue parameter, no use of teThresh
+		% 1: default value of 1, in areas with grain radius below teThresh
+		% 2: default value of 1, in areas with grain radius below teThresh and areas of dry snow (not bare ice or wet) at the surface
+
+		swIdx  = NaN; % apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 1, if aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002))
 
 		denIdx = NaN; %densification model to use (default is 2):
-			      % 1 = emperical model of Herron and Langway (1980)
-			      % 2 = semi-emperical model of Anthern et al. (2010)
-			      % 3 = DO NOT USE: physical model from Appendix B of Anthern et al. (2010)
-			      % 4 = DO NOT USE: emperical model of Li and Zwally (2004)
-			      % 5 = DO NOT USE: modified emperical model (4) by Helsen et al. (2008)
-			      % 6 = Antarctica semi-emperical model of Ligtenberg et al. (2011)
-			      % 7 = Greenland semi-emperical model of Kuipers Munneke et al. (2015)
+		% 1 = emperical model of Herron and Langway (1980)
+		% 2 = semi-emperical model of Anthern et al. (2010)
+		% 3 = DO NOT USE: physical model from Appendix B of Anthern et al. (2010)
+		% 4 = DO NOT USE: emperical model of Li and Zwally (2004)
+		% 5 = DO NOT USE: modified emperical model (4) by Helsen et al. (2008)
+		% 6 = Antarctica semi-emperical model of Ligtenberg et al. (2011)
+		% 7 = Greenland semi-emperical model of Kuipers Munneke et al. (2015)
 
 		dsnowIdx = NaN; %model for fresh snow accumulation density (default is 1):
-				% 0 = Original GEMB value, 150 kg/m^3
-				% 1 = Antarctica value of fresh snow density, 350 kg/m^3
-				% 2 = Greenland value of fresh snow density, 315 kg/m^3, Fausto et al. (2008)
-				% 3 = Antarctica model of Kaspers et al. (2004)
-				% 4 = Greenland model of Kuipers Munneke et al. (2015)
+		% 0 = Original GEMB value, 150 kg/m^3
+		% 1 = Antarctica value of fresh snow density, 350 kg/m^3
+		% 2 = Greenland value of fresh snow density, 315 kg/m^3, Fausto et al. (2018)
+		% 3 = Antarctica model of Kaspers et al. (2004)
+		% 4 = Greenland model of Kuipers Munneke et al. (2015)
 
 		zTop  = NaN; % depth over which grid length is constant at the top of the snopack (default 10) [m]
@@ -92,16 +101,25 @@
 
 		%specific albedo parameters:
+		%Method 1
+		dswdiffrf = NaN; %downward diffusive shortwave radiation flux [W/m^2]
+		szaValue = NaN; %Solar Zenith Angle [degree]
+		cotValue = NaN; %Cloud Optical Thickness
+		ccsnowValue = NaN; %concentration of light absorbing carbon for snow [ppm1]
+		cciceValue = NaN; %concentration of light absorbing carbon for ice [ppm1]
 		%Method 1 and 2:
 		aSnow = NaN; % new snow albedo (0.64 - 0.89)
 		aIce  = NaN; % range 0.27-0.58 for old snow
-			     %Method 3: Radiation Correction Factors -> only used for met station data and Greuell & Konzelmann, 1994 albedo
+		%Method 3: Radiation Correction Factors -> only used for met station data and Greuell & Konzelmann, 1994 albedo
 		cldFrac = NaN; % average cloud amount
-			       %Method 4: additonal tuning parameters albedo as a funtion of age and water content (Bougamont et al., 2005)
+		%Method 4: additonal tuning parameters albedo as a funtion of age and water content (Bougamont et al., 2005)
 		t0wet = NaN; % time scale for wet snow (15-21.9)
 		t0dry = NaN; % warm snow timescale (30)
 		K     = NaN; % time scale temperature coef. (7)
 		adThresh = NaN; %Apply aIdx method to all areas with densities below this value,
-		                %or else apply direct input value from aValue, allowing albedo to be altered.
-				%Default value is rho water (1023 kg m-3).
+		%or else apply direct input value from aValue, allowing albedo to be altered.
+		%Default value is rho water (1023 kg m-3).
+		teThresh = NaN; %Apply eIdx method to all areas with grain radii below this value,
+		%or else apply direct input value from teValue, allowing emissivity to be altered.
+		%Default value is a effective grain radius of 10 mm.
 
 		%densities:
@@ -115,5 +133,6 @@
 		requested_outputs      = {};
 
-		%Several fields are missing from the standard GEMB model, which are capture intrinsically by ISSM.
+		%Several fields are missing from the standard GEMB model, which are 
+		%captured intrinsically by ISSM.
 		%dateN: that's the last row of the above fields.
 		%dt:    included in dateN. Not an input.
@@ -132,163 +151,4 @@
 			end
 		end % }}}
-		function self = extrude(self,md) % {{{
-
-			self.Ta=project3d(md,'vector',self.Ta,'type','node');
-			self.V=project3d(md,'vector',self.V,'type','node');
-			self.dswrf=project3d(md,'vector',self.dswrf,'type','node');
-			self.dswrf=project3d(md,'vector',self.dswrf,'type','node');
-			self.P=project3d(md,'vector',self.P,'type','node');
-			self.eAir=project3d(md,'vector',self.eAir,'type','node');
-			self.pAir=project3d(md,'vector',self.pAir,'type','node');
-
-			if (aIdx == 0) & ~isnan(self.aValue)
-				self.aValue=project3d(md,'vector',self.aValue,'type','node');
-			end
-			if ~isnan(self.teValue)
-				self.teValue=project3d(md,'vector',self.teValue,'type','node');
-			end
-
-
-		end % }}}
-		function list = defaultoutputs(self,md) % {{{
-			list = {'SmbMassBalance'};
-		end % }}}
-		function self = setdefaultparameters(self,mesh,geometry) % {{{
-
-			self.isgraingrowth=1;
-			self.isalbedo=1;
-			self.isshortwave=1;
-			self.isthermal=1;
-			self.isaccumulation=1;
-			self.ismelt=1;
-			self.isdensification=1;
-			self.isturbulentflux=1;
-			self.isclimatology=0;
-			self.isconstrainsurfaceT=0;
-
-			self.aIdx = 1;
-			self.swIdx = 1;
-			self.denIdx = 2;
-			self.dsnowIdx = 1;
-			self.zTop=10*ones(mesh.numberofelements,1);
-			self.dzTop = .05* ones (mesh.numberofelements,1);
-			self.dzMin = self.dzTop/2;
-			self.InitDensityScaling = 1.0;
-			self.ThermoDeltaTScaling = 1/11;
-
-			self.Vmean=10.0*ones(mesh.numberofelements,1);
-
-			self.zMax=250*ones(mesh.numberofelements,1);
-			self.zMin=130*ones(mesh.numberofelements,1);
-			self.zY = 1.025*ones(mesh.numberofelements,1);
-			self.outputFreq = 30;
-
-			%additional albedo parameters
-			self.aSnow = 0.85;
-			self.aIce = 0.48;
-			self.cldFrac = 0.1;
-			self.t0wet = 15;
-			self.t0dry = 30;
-			self.K = 7;
-			self.adThresh = 1023;
-
-			self.teValue = ones(mesh.numberofelements,1);
-			self.aValue = self.aSnow*ones(mesh.numberofelements,1);
-
-			self.Dzini=0.05*ones(mesh.numberofelements,2);
-			self.Dini=910.0*ones(mesh.numberofelements,2);
-			self.Reini=2.5*ones(mesh.numberofelements,2);
-			self.Gdnini=0.0*ones(mesh.numberofelements,2);
-			self.Gspini=0.0*ones(mesh.numberofelements,2);
-			self.ECini=0.0*ones(mesh.numberofelements,1);
-			self.Wini=0.0*ones(mesh.numberofelements,2);
-			self.Aini=self.aSnow*ones(mesh.numberofelements,2);
-			self.Tini=273.15*ones(mesh.numberofelements,2);
-			% 		/!\ Default value of Tini must be equal to Tmean but don't know Tmean yet (computed when atmospheric forcings are interpolated on mesh).
-			% 		If initialization without restart, this value will be overwritten when snow parameters are retrieved in Element.cpp
-			self.Sizeini=2*ones(mesh.numberofelements,1);
-
-		end % }}}
-		function md = checkconsistency(self,md,solution,analyses) % {{{
-
-			md = checkfield(md,'fieldname','smb.isgraingrowth','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isalbedo','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isshortwave','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isthermal','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isaccumulation','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.ismelt','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isdensification','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isturbulentflux','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isclimatology','values',[0 1]);
-			md = checkfield(md,'fieldname','smb.isconstrainsurfaceT','values',[0 1]);
-
-			md = checkfield(md,'fieldname','smb.Ta','timeseries',1,'NaN',1,'Inf',1,'>',273-100,'<',273+100); %-100/100 celsius min/max value
-			md = checkfield(md,'fieldname','smb.V','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<',45,'size',size(self.Ta)); %max 500 km/h
-			md = checkfield(md,'fieldname','smb.dswrf','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',1400,'size',size(self.Ta));
-			md = checkfield(md,'fieldname','smb.dlwrf','timeseries',1,'NaN',1,'Inf',1,'>=',0,'size',size(self.Ta));
-			md = checkfield(md,'fieldname','smb.P','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',200,'size',size(self.Ta));
-			md = checkfield(md,'fieldname','smb.eAir','timeseries',1,'NaN',1,'Inf',1,'size',size(self.Ta));
-
-			if (self.isclimatology)
-				md = checkfield(md,'fieldname', 'smb.Ta', 'size',[md.mesh.numberofelements+1],...
-						'message',['Ta must have md.mesh.numberofelements+1 rows in order to force a climatology']);
-				md = checkfield(md,'fieldname', 'smb.V', 'size',[md.mesh.numberofelements+1],...
-						'message',['V must have md.mesh.numberofelements+1 rows in order to force a climatology']);
-				md = checkfield(md,'fieldname', 'smb.dswrf', 'size',[md.mesh.numberofelements+1],...
-						'message',['dswrf must have md.mesh.numberofelements+1 rows in order to force a climatology']);
-				md = checkfield(md,'fieldname', 'smb.dlwrf', 'size',[md.mesh.numberofelements+1],...
-						'message',['dlwrf must have md.mesh.numberofelements+1 rows in order to force a climatology']);
-				md = checkfield(md,'fieldname', 'smb.P', 'size',[md.mesh.numberofelements+1],...
-						'message',['P must have md.mesh.numberofelements+1 rows in order to force a climatology']);
-				md = checkfield(md,'fieldname', 'smb.eAir', 'size',[md.mesh.numberofelements+1],...
-						'message',['eAir must have md.mesh.numberofelements+1 rows in order to force a climatology']);
-			end
-
-			md = checkfield(md,'fieldname','smb.Tmean','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>',273-100,'<',273+100); %-100/100 celsius min/max value
-			md = checkfield(md,'fieldname','smb.C','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>=',0);
-			md = checkfield(md,'fieldname','smb.Vmean','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>=',0);
-			md = checkfield(md,'fieldname','smb.Tz','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>=',0,'<=',5000);
-			md = checkfield(md,'fieldname','smb.Vz','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>=',0,'<=',5000);
-
-			md = checkfield(md,'fieldname','smb.teValue','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',1);
-
-			md = checkfield(md,'fieldname','smb.aIdx','NaN',1,'Inf',1,'values',[0,1,2,3,4]);
-			md = checkfield(md,'fieldname','smb.swIdx','NaN',1,'Inf',1,'values',[0,1]);
-			md = checkfield(md,'fieldname','smb.denIdx','NaN',1,'Inf',1,'values',[1,2,3,4,5,6,7]);
-			md = checkfield(md,'fieldname','smb.dsnowIdx','NaN',1,'Inf',1,'values',[0,1,2,3,4]);
-
-			md = checkfield(md,'fieldname','smb.zTop','NaN',1,'Inf',1,'>=',0);
-			md = checkfield(md,'fieldname','smb.dzTop','NaN',1,'Inf',1,'>',0);
-			md = checkfield(md,'fieldname','smb.dzMin','NaN',1,'Inf',1,'>',0);
-			md = checkfield(md,'fieldname','smb.zY','NaN',1,'Inf',1,'>=',1);
-			md = checkfield(md,'fieldname','smb.outputFreq','NaN',1,'Inf',1,'>',0,'<',10*365); %10 years max
-			md = checkfield(md,'fieldname','smb.InitDensityScaling','NaN',1,'Inf',1,'>=',0,'<=',1);
-			md = checkfield(md,'fieldname','smb.ThermoDeltaTScaling','NaN',1,'Inf',1,'>=',0,'<=',1);
-			md = checkfield(md,'fieldname','smb.adThresh','NaN',1,'Inf',1,'>=',0);
-
-			switch self.aIdx,
-				case 0
-					md = checkfield(md,'fieldname','smb.aValue','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',1);
-				case {1 2}
-					md = checkfield(md,'fieldname','smb.aSnow','NaN',1,'Inf',1,'>=',.64,'<=',.89);
-					md = checkfield(md,'fieldname','smb.aIce','NaN',1,'Inf',1,'>=',.27,'<=',.58);
-				case 3
-					md = checkfield(md,'fieldname','smb.cldFrac','NaN',1,'Inf',1,'>=',0,'<=',1);
-				case 4
-					md = checkfield(md,'fieldname','smb.t0wet','NaN',1,'Inf',1,'>=',15,'<=',21.9);
-					md = checkfield(md,'fieldname','smb.t0dry','NaN',1,'Inf',1,'>=',30,'<=',30);
-					md = checkfield(md,'fieldname','smb.K','NaN',1,'Inf',1,'>=',7,'<=',7);
-			end
-
-			%check zTop is < local thickness:
-			he=sum(md.geometry.thickness(md.mesh.elements),2)/size(md.mesh.elements,2);
-			if any(he<self.zTop),
-				error('SMBgemb consistency check error: zTop should be smaller than local ice thickness');
-			end
-			md = checkfield(md,'fieldname','smb.steps_per_step','>=',1,'numel',[1]);
-			md = checkfield(md,'fieldname','smb.averaging','numel',[1],'values',[0 1 2]);
-			md = checkfield(md,'fieldname','smb.requested_outputs','stringrow',1);
-
-		end % }}}
 		function disp(self) % {{{
 
@@ -303,10 +163,11 @@
 			fielddisplay(self,'isdensification','run densification module (default true)');
 			fielddisplay(self,'isturbulentflux','run turbulant heat fluxes module (default true)');
-			fielddisplay(self,'isconstrainsurfaceT','constrain surface temperatures to air temperature, turn off EC and surface flux contribution to surface temperature change');
-			fielddisplay(self,'isclimatology','repeat all forcings when past last forcing time (default false)');
+			fielddisplay(self,'isconstrainsurfaceT','constrain surface temperatures to air temperature, turn off EC and surface flux contribution to surface temperature change (default false)');
+			fielddisplay(self,'isdeltaLWup','set to true to invoke a bias in the long wave upward spatially, specified by dulwrfValue (default false)'); 
 			fielddisplay(self,'Ta','2 m air temperature, in Kelvin');
 			fielddisplay(self,'V','wind speed (m s-1)');
-			fielddisplay(self,'dlwrf','downward shortwave radiation flux [W/m^2]');
-			fielddisplay(self,'dswrf','downward longwave radiation flux [W/m^2]');
+			fielddisplay(self,'dswrf','downward shortwave radiation flux [W/m^2]');
+			fielddisplay(self,'dswdiffrf','downward diffusive portion of shortwave radiation flux (default to 0) [W/m^2]');
+			fielddisplay(self,'dlwrf','downward longwave radiation flux [W/m^2]');
 			fielddisplay(self,'P','precipitation [mm w.e. / m^2]');
 			fielddisplay(self,'eAir','screen level vapor pressure [Pa]');
@@ -328,11 +189,17 @@
 			fielddisplay(self,'adThresh',{'Apply aIdx method to all areas with densities below this value,','or else apply direct input value from aValue, allowing albedo to be altered.'});
 			fielddisplay(self,'aIdx',{'method for calculating albedo and subsurface absorption (default is 1)',...
-					    '0: direct input from aValue parameter',...
-					    '1: effective grain radius [Gardner & Sharp, 2009]',...
-					    '2: effective grain radius [Brun et al., 1992; LeFebre et al., 2003], with swIdx=1, SW penetration follows grain size in 3 spectral bands (Brun et al., 1992)',...
-					    '3: density and cloud amount [Greuell & Konzelmann, 1994]',...
-					    '4: exponential time decay & wetness [Bougamont & Bamber, 2005]'})
-
+				'0: direct input from aValue parameter',...
+				'1: effective grain radius [Gardner & Sharp, 2009]',...
+				'2: effective grain radius [Brun et al., 1992; LeFebre et al., 2003], with swIdx=1, SW penetration follows grain size in 3 spectral bands (Brun et al., 1992)',...
+				'3: density and cloud amount [Greuell & Konzelmann, 1994]',...
+				'4: exponential time decay & wetness [Bougamont & Bamber, 2005]'})
+
+			fielddisplay(self,'dulwrfValue','Specified bias to be applied to the outward long wave radiation every element (W/m-2, +upward)');
 			fielddisplay(self,'teValue','Outward longwave radiation thermal emissivity forcing at every element (default in code is 1)');
+			fielddisplay(self,'teThresh',{'Apply eIdx method to all areas with effective grain radius below this value,','or else apply direct input value from teValue, allowing emissivity to be altered.'});
+			fielddisplay(self,'eIdx',{'method for calculating emissivity (default is 1)',...
+				'0: direct input from teValue parameter, no use of teThresh',...
+				'1: default value of 1, in areas with grain radius below teThresh',...
+				'2: default value of 1, in areas with grain radius below teThresh and areas of dry snow (not bare ice or wet) at the surface'});
 
 			%snow properties init
@@ -345,15 +212,20 @@
 			fielddisplay(self,'Wini','Initial snow water content when restart [kg m-2]');
 			fielddisplay(self,'Aini','Initial albedo when restart [-]');
+			fielddisplay(self,'Adiffini','Initial diffusive radiation albedo when restart (default to 1) [-]');
 			fielddisplay(self,'Tini','Initial snow temperature when restart [K]');
 			fielddisplay(self,'Sizeini','Initial number of layers when restart [-]');
 
-
 			%additional albedo parameters:
+			fielddisplay(self,'aValue','Albedo forcing at every element');
 			switch self.aIdx
-				case {0 5}
-					fielddisplay(self,'aValue','Albedo forcing at every element.  Used only if aIdx == {0,5}.');
 				case {1 2}
 					fielddisplay(self,'aSnow','new snow albedo (0.64 - 0.89)');
 					fielddisplay(self,'aIce','albedo of ice (0.27-0.58)');
+					if self.aIdx==1
+						fielddisplay(self,'szaValue','Solar Zenith Angle [degree]');
+						fielddisplay(self,'cotValue','Cloud Optical Thickness');
+						fielddisplay(self,'ccsnowValue','concentration of light absorbing carbon for snow [ppm1]');
+						fielddisplay(self,'cciceValue','concentration of light absorbing carbon for snow [ppm1]');
+					end
 				case 3
 					fielddisplay(self,'cldFrac','average cloud amount');
@@ -364,19 +236,19 @@
 			end
 
-			fielddisplay(self,'swIdx','apply all SW to top grid cell (0) or allow SW to penetrate surface (1) [default 1, with snow density (taken from Bassford, 2004)]');
+			fielddisplay(self,'swIdx','apply all SW to top grid cell (0) or allow SW to penetrate surface (1) [default 1, if aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002)]');
 			fielddisplay(self,'denIdx',{'densification model to use (default is 2):',...
-					    '1 = emperical model of Herron and Langway (1980)',...
-					    '2 = semi-emperical model of Anthern et al. (2010)',...
-					    '3 = DO NOT USE: physical model from Appendix B of Anthern et al. (2010)',...
-					    '4 = DO NOT USE: emperical model of Li and Zwally (2004)',...
-					    '5 = DO NOT USE: modified emperical model (4) by Helsen et al. (2008)',...
-					    '6 = Antarctica semi-emperical model of Ligtenberg et al. (2011)',...
-					    '7 = Greenland semi-emperical model of Kuipers Munneke et al. (2015)'});
+				'1 = emperical model of Herron and Langway (1980)',...
+				'2 = semi-emperical model of Anthern et al. (2010)',...
+				'3 = DO NOT USE: physical model from Appendix B of Anthern et al. (2010)',...
+				'4 = DO NOT USE: emperical model of Li and Zwally (2004)',...
+				'5 = DO NOT USE: modified emperical model (4) by Helsen et al. (2008)',...
+				'6 = Antarctica semi-emperical model of Ligtenberg et al. (2011)',...
+				'7 = Greenland semi-emperical model of Kuipers Munneke et al. (2015)'});
 			fielddisplay(self,'dsnowIdx',{'model for fresh snow accumulation density (default is 1):',...
-					    '0 = Original GEMB value, 150 kg/m^3',...
-					    '1 = Antarctica value of fresh snow density, 350 kg/m^3',...
-					    '2 = Greenland value of fresh snow density, 315 kg/m^3, Fausto et al. (2008)',...
-					    '3 = Antarctica model of Kaspers et al. (2004), Make sure to set Vmean accurately',...
-					    '4 = Greenland model of Kuipers Munneke et al. (2015)'});
+				'0 = Original GEMB value, 150 kg/m^3',...
+				'1 = Antarctica value of fresh snow density, 350 kg/m^3',...
+				'2 = Greenland value of fresh snow density, 315 kg/m^3, Fausto et al. (2018)',...
+				'3 = Antarctica model of Kaspers et al. (2004), Make sure to set Vmean accurately',...
+				'4 = Greenland model of Kuipers Munneke et al. (2015)'});
 
 			fielddisplay(self, 'steps_per_step', 'number of smb steps per time step');
